%close all
clear all

global nrep Mx My Mr Mtheta OrdresAng MOA

% Ajust the position of the center of the images
cx=202;                 % center of x
cy=147;                 % center of y

% global parameters
nbpx=400;   % number of pixels maximum
rep='../../MyImagesVMI/Pump266_Probe333_20190823_1741/'; 
bg='';                  % imge background to subtract
bgcount=0;              % general background constant to substract
dist=1;                  % dist=1 is the size ratio of the pixels size x/y
rotate=0;
OrdresAng=40;           %restrict the number of possible orders of legendre polynomial

lgt=length(dir([rep,'/VMI*']))-length(dir([rep,'/Speeddistrib_Inv*']));% mesure the number of file in the directory

for ind=1:lgt            % first test the parameters on the first image commenting the ':lgt' part

    figure(1)
    Img_Raw=importdata([rep,'VMI',num2str(ind),'.txt']);Img_Raw=Img_Raw-bgcount;
    subplot(2,3,1)
    pcolor(Img_Raw);shading flat;axis image;title('Initial image');xlabel('Momentum p_x (px)');ylabel('Momentum p_y (px)')
    
    % contruction of necessary variables (needed to be done at the first loop)
    if ind==1
        [sy,sx]=size(Img_Raw);
        vy=[1:sy]-cy;
        vx=[1:sx]-cx;
        nbpx=min(abs([vy(1),vy(end),vx(1),vx(end)]));

        Mx=(vy'*0+1)*vx;
        My=vy'*(vx*0+1);
        Z1=Mx+i*My*dist;
        Mrcart=abs(Z1);
        Mthetacart=angle(Z1);

        r=[1:nbpx];
        theta=[-pi:pi/nbpx:pi];
        OA=[1:length(theta)]-(length(theta)-1)/2;
        MOA=(r'*0+1)*OA;
        Mtheta=(r'*0+1)*theta;
        Mr=r'*(theta*0+1);
        Zrot=Mr.*exp(i*(Mtheta-rotate/180*pi));
        Mxpolrot=real(Zrot);
        Mypolrot=imag(Zrot);
        Z=Mr.*exp(i*Mtheta);
        Mxpol=real(Z);
        Mypol=imag(Z);
    end

    % Representation in polar coordinate
    Img_pol=interp2(Mx,My,Img_Raw,Mxpolrot,Mypolrot);
    subplot(2,3,[2,5])
    pcolor(theta+pi/2,r,Img_pol);shading flat;colorbar;xlabel('Angle (rad)');ylabel('Speed (px)')
    line(0*[1 1],[0 nbpx],'color','white');line(pi*[1 1],[0 nbpx],'color','white');% to tune the angle
    title('Raw image in polar coordinate')

    subplot(2,3,[3,6])
    Img_polf=Fourier_Map(Img_pol);
    Img_polf=filtre_ang2bis(Img_pol);
    pcolor(theta+pi/2,r,Img_polf);shading interp;colorbar;xlabel('Angle (rad)');ylabel('Speed (px)')
    title('Angularly filtered image')

    % back in cartesian coordinate
    Img_ready=interp2(Mtheta,Mr,Img_pol,Mthetacart,Mrcart);Img_ready(isnan(Img_ready))=0;
    subplot(2,3,4)
    pcolor(Img_ready);shading interp;axis image;xlabel('Momentum p_x (px)');ylabel('Momentum p_y (px)')
    title('Image ready to Abel inverse')
    

    %% inversion procedure
    Img_Inv=FAbel_inversion(Img_ready,cx);

    Img_poli=interp2(Mx,My,Img_Inv,Mxpol,Mypol);
    Img_polif=filtre_ang2bis(Img_poli);
    Img_Invf=interp2(Mtheta,Mr,Img_polif,Mthetacart,Mrcart);Img_Invf(isnan(Img_Invf))=0;
    
    Speed(:,1)=r;
    Speed(:,2)=sum(Img_polif.*abs(cos(Mtheta)).*Mr,2);
    


    
    %% Result of the inversion
    figure(2)
    subplot(2,2,1);
    pcolor(Img_ready);shading interp;axis image;title('Image to Abel inverse')
    subplot(2,2,2);
    pcolor(Img_Inv);shading interp;axis image;title('Inversed image')
    subplot(2,2,3);
    pcolor(Img_Invf);shading interp;axis image;title('Angularly filtered inversed image')
    subplot(2,2,4)
    plot(Speed(:,1),Speed(:,2),'linewidth',2,'color','r');title('Speed distribution');xlabel('radial distance');ylabel('Intensity')
    pause(0.01)
    
    % save the speed distribution and the abel inversed image
    save([rep,'Speeddistrib_',num2str(ind),'.txt'],'Speed','-ascii');
    save([rep,'VMI_Inv_',num2str(ind),'.txt'],'Img_Invf','-ascii');
    
    out1=[0 theta];
    out2=[r' Img_polif];
    out=[out1' out2']';
    save([rep,'VMI_InvPol_',num2str(ind),'.txt'],'out','-ascii');
    
end