clear all
%close all


rep='../../MyImagesVMI/Pump266_Probe333_20190823_1741/'; 
Calibration=1.87e-4;

lgt=length(dir([rep,'/Speeddistrib_*']));% mesure the number of file in the directory
time=importdata([rep,'/Time.txt']);

for ind=1:lgt
    ind
    Sp=importdata([rep ,'Speeddistrib_',num2str(ind),'.txt']);
    M(ind,:)=Sp(:,2);
end
speed=Sp(:,1);

% plot the 2D map
figure(1)
subplot(2,2,1)
pcolor(speed,time,M);shading flat;colorbar
ylabel('time (fs)');xlabel('Speed (uncalibrated px)')
title('Speed distribution as a function of the time delay')

%% Calibration the Energy Axis
Eph=1.55;       % fundamental photon energy
ISp=sum(M,1);   % integrated signal over all times
subplot(2,2,3)
plot(speed,ISp)
xlabel('Speed (px)')
ylabel('Integrated intensity')

EnergyI=(3*Eph - 2.41)*127/(127+15);
EnergyISO=(3*Eph - 2.41-0.943)*127/(127+15);

calib=[[0 0]' [78.7 EnergyISO]' [103.3 EnergyI]'];% [[px1 eV1]' [px2 eV2]' ...]
for indc=1: length(calib')
    line(calib(1,indc)*[1 1],[0 max(ISp)],'color','k')    
end

E=Calibration*speed.^2;
subplot(2,2,4)
plot(calib(1,:),calib(2,:),'o',speed,E,'r')

% normalization with this new step
dE=diff(E);dE(length(dE)+1)=dE(length(dE));
for ind=1:lgt;
     MI(ind,:)= M(ind,:)./dE';
end
subplot(2,2,2);
pcolor(E,time,MI);shading flat;colorbar
ylabel('time (fs)')
xlabel('Energy (eV)')
title('Map signal')


%% save the map
Vout=[0,E'];
Mout=[time,MI];
Mout=[Vout' Mout']';

save([rep,'MapVMI.txt'],'Mout','-ascii')