clear all
%close all

figure(1);clf
%% load the experiment
rep='../../MyImagesVMI/Pump266_Probe333_20190823_1741/'; 
A=importdata([rep,'MapVMI.txt']);
time=A([2:end],1);
E=A(1,[2:end]);dE=diff(E);dE(end+1)=dE(end);MdE=(time*0+1)*dE;
MI=A([2:end],[2:end]);
figure(1)
subplot(1,2,1);hold all
pcolor(E,time,MI);shading flat;colorbar
ylabel('time (fs)')
xlabel('Energy (eV)')
title('Map signal')

%% define integration range
integr=[[1 1.4]' [1.8 2.2]'];

for ind=1:length(integr(1,:))
    % indicate the integration on the graph
    subplot(1,2,1)
    line(integr(1,ind)*[1 1],[min(time) max(time)],'color','white');
    line(integr(2,ind)*[1 1],[min(time) max(time)],'color','white');
    
    % find the position of the limit of the integration range
    [val,pos1]=min(abs(E-integr(1,ind)));
    [val,pos2]=min(abs(E-integr(2,ind)));
    
    % integrate
    transient(ind,:)=sum(MI(:,[pos1:pos2]).*MdE(:,[pos1:pos2]),2);
    
    % ajustement
    % initial Guess
    c(1)=max(transient(ind,:))-min(transient(ind,:));   % Estimated amplitude
    c(2)=3;                                             % 0 is not a good initial guess
    c(3)=100;                                           % slope
    c(4)=min(transient(ind,:));                         % background
    [f,p,kvg,iter,corp,covp,covr,stdresid,Z,r2]=leasqr(time,transient(ind,:),c,'Sigmo',0.00005,30);
    stdev=sqrt(diag(covp));  %Uncertainity on the parameters
    subplot(1,2,2)
    hold all
    plot(time, transient(ind,:),time,f)
    xlabel('Time (fs)');ylabel('Intensity (arb. unit)')
    ['optimized parameter for the channel ',num2str(ind)]
    ['Amplitude= ', num2str(p(1)),' +/- ',num2str(stdev(1))]
    ['t_0= ',       num2str(p(2)),' +/- ',num2str(stdev(2))]    
    ['slope= ',     num2str(p(3)),' +/- ',num2str(stdev(3))]    
    ['background= ',num2str(p(4)),' +/- ',num2str(stdev(4))]
end

