clear all
%close all

figure(1);clf
%% load the experiment
rep='../../MyImagesVMI/Pump200_Probe333_20190823_1802/'; 
time=importdata([rep,'Time.txt']);
cx=202;                 % Center of the VMI image among x
cy=147;                 % Center of the VMI image among y

%% define integration range
integr=[128 140];

for ind=1:length(time)

    
    VMIpolloc=importdata([rep,'VMI_InvPol_',num2str(ind),'.txt']);
    theta    =VMIpolloc(1,[2:end])+pi/2;
    r        =VMIpolloc([2:end],1);
    VMIpolloc=VMIpolloc([2:end],[2:end]);
    subplot(2,2,1)
    pcolor(theta,r,VMIpolloc);shading flat;
    line([-pi/2 3*pi/2],integr(1)*[1 1],'color','w');
    line([-pi/2 3*pi/2],integr(2)*[1 1],'color','w');
        
    % find the position of the limit of the integration range
    [val,pos1]=min(abs(r-integr(1)));
    [val,pos2]=min(abs(r-integr(2)));
    
    % integrate
    DAng=sum(VMIpolloc([pos1:pos2],:),1)+1e-10*randn(size(theta));
    
    % ajustement
    % initial Guess
    c(1)=max(DAng);   % Estimated amplitude
    c(2)=-0.8;        % beta2
    [f,ploc,kvg,iter,corp,covp,covr,stdresid,Z,r2]=leasqr(theta',DAng,c,'Beta2',0.00005,30);
    stdevloc=sqrt(diag(covp));  %Uncertainity on the parameters
    p(ind,:)=ploc;
    stdev(ind,:)=stdevloc;  
    subplot(2,2,3)
    plot(theta,DAng,'ko',theta,f,'r');xlabel('theta');ylabel('intensity')
    pause(0.01)
end

subplot(2,2,2)
plot(time,p(:,1))
ylabel('Intensity (arb. unit)')
xlabel('Time (fs)')
subplot(2,2,4)
plot(time,p(:,2))
ylabel('Anisotropy \beta_2')
ylim([-1 2])
xlabel('Time (fs)')