function [VMIimageout,pxx,pxy]=makeVMImap(E,IE,FWHME,beta)
% E     list of energies where a ring may appears
% IE    Respective intensities
% FWHME Respective width
% beta  Anisotropy

global VMIEmax MeanEvent cx cy resolution
  
  nbpts=256;
  vmax=sqrt(2*VMIEmax);
  v=[1:vmax/(nbpts-1):vmax];
  Vloc=sqrt(2*E);
  
  % pixel of the camera
  pxx=[1:resolution(1)]-cx;
  pxy=[1:resolution(2)]-cy;
  Mpxx=(pxy'*0+1)*pxx;
  Mpxy=pxy'*(pxx*0+1);
  pxZ=(Mpxx+i*Mpxy)*exp(i*pi/2);
  pxV=abs(pxZ)*vmax/abs(pxy(1));    % radial distance of the speed
  pxA=angle(pxZ.*exp(i*0.03));       % angle with the polarization axis
  
  
  
  VMIimageout=pxV*0;        % empty image
  % contruction of the VMI density image
  for ind=1:length(E)
    VMIloc=exp(-4*log(2)*(pxV-Vloc(ind)).^2/FWHME(ind).^2).*(1+beta(ind)/2*(3*cos(pxA).^2-1));
    VMIlocNorm=2*pi*sum(sum(VMIloc.*sin(abs(pxA))));           % normalization to make the integral =1;
    VMIimageout=VMIimageout+ IE(ind)*VMIloc/VMIlocNorm;
  end
  
  
  
  
  % abel projection
  VMIimageout=Abel_projection(VMIimageout,cx);
  
  
  
  
  % translate the density probability in given shot in the detector
  if (MeanEvent ~=0)
  VMIimageoutss=pxV*0;        % empty image
  [S1,S2]=size(VMIimageout);
  vectorVMIimageout=reshape(VMIimageout,S1*S2,1);
  vectorVMIimageout2=vectorVMIimageout*0;
  vectorVMIimageout=cumsum(vectorVMIimageout);
  vectorVMIimageout=vectorVMIimageout/max(vectorVMIimageout);
  %plot(vectorVMIimageout);pause(0.1)
    for (ind=0:abs(round(MeanEvent*sum(sum(VMIimageout)))))
             [val,pos]=min(abs(vectorVMIimageout-rand));
             vectorVMIimageout2(pos)=vectorVMIimageout2(pos)+1;
    end
    VMIimageout=reshape(vectorVMIimageout2,S1,S2); % in this case the impact is on one pixel
    
    % transformation to get a Gaussian impact 
    Vconv=[-10:10];Mconv=(Vconv'*0+1)*Vconv;Zconv=Mconv+i*Mconv';
    MG=exp(-4*log(2)*abs(Zconv).^2/(2)^2);MG=MG/sum(sum(MG));
    VMIimageout=conv2(VMIimageout,MG,'same');
    
  else % if we are not in counting mode we see the ambient noise
    VMIimageout=VMIimageout+max(max(VMIimageout))*0.02*abs(randn(size(VMIimageout)));
  end
  
%endfunction % for Octave
